{-# OPTIONS -fglasgow-exts #-}

module TypeChecker.Patterns where

import Syntax.Position
import Syntax.Internal
import Syntax.Values
import TypeChecker.Values
import TypeChecker.Monad
import TypeChecker.Abstractions

import Utils.Monads

patternVars :: Pattern -> [Name]
patternVars (WildP _)		= []
patternVars (VarP x)		= [x]
patternVars (PairP _ p q)	= patternVars p ++ patternVars q
patternVars (ConP _ _ hs ps)	= concatMap patternVars (hs ++ ps)

patternInstantiation :: Pattern -> [Value]
patternInstantiation = inst []
    where
	inst r (WildP _)	= [vProjs (vBId 0) r]
	inst r (VarP x)		= [vProjs (vBId 0) r]
	inst r (PairP _ p q)	= inst (VSnd:r) q ++ inst (VFst:r) p
	inst r (ConP _ _ _ _)	= error "impossible: TypeChecker.Patterns.patternInstantiation (ConP _ _ _ _)"

patName (WildP _)	= "_"
patName (VarP x)	= nameString x
patName (PairP _ p q)	= patName p ++ patName q
patName (ConP _ _ _ _)	= error "impossible: TypeChecker.Patterns.patName (ConP _ _ _ _)"


