
data Nat : Set where
  zero : Nat
  succ : Nat -> Nat

(+) : Nat -> Nat -> Nat
0      + m = m
succ n + m = succ (n + m)

data Vec' (A:Set) : Nat -> Set where
  nl  : Vec' A zero
  cns : (n : Nat) -> A -> Vec' A n -> Vec' A (succ n)

head' (A:Set)(n : Nat) : Vec' A (succ n) -> A
head' (cns m x xs) = x

neck (A:Set)(n:Nat) : Vec' A (succ (succ n)) -> A
neck (cns (succ m) x (cns m x' xs)) = x'

data Vec (A:Set) : Nat -> Set where
  nil : Vec A zero
  (::) (n:Nat) : A -> Vec A n -> Vec A (succ n)

data (×) (A,B:Set) : Set where
  pair : A -> B -> A × B

head (A:Set)(n:Nat) : Vec A (succ n) -> A
head (x :: xs) = x

zip (A, B : Set)(n : Nat) : Vec A n -> Vec B n -> Vec (A × B) n
zip []	      []	= []
zip (x :: xs) (y :: ys) = pair x y :: zip xs ys

mapFst (A, B, C : Set) : (f : A -> B) -> A × C -> B × C
mapFst f (pair x y) = pair (f x) y

split (A : Set) : (n, m : Nat) -> Vec A (n + m) -> Vec A n × Vec A m
split (succ n) m (x :: xs) = mapFst ((::) x) (split n m xs)
split 0	n xs		   = pair nil xs

